#include <cstdint>
#include <iostream>

void print(auto whatever) {
	std::cout << whatever << '\n';
}

auto succ(auto num) {
	return num + 1;
}

void inc(auto& num) {
	++num;
}

auto slow_pow(auto num, int exp) {
	decltype(num) result = 1;
	for (; exp > 0; --exp) {
		result *= num;
	}
	return result;
}

int main() {
	print(1);
	print(3.14);
	print("HELLO");

	int i = 10;
	double d = 3.14;

	print(succ(i));
	print(succ(d));

	inc(i);
	inc(d);

	print(i);
	print(d);

	print(slow_pow(10, 4));
	print(slow_pow(3.14, 5));

	std::uint64_t two = 2;
	print(slow_pow(two, 63));
}
